#include <stdio.h>
#include <math.h>
#include <time.h>
#include <float.h>
#define max(a,b) (a>b)?a:b
#define NZ 1048576
#define N2 NZ/2
#define FLT_REL 0.11920928955078e-06
static float x[NZ][2],w[N2][2],z[NZ][2];
/* test driver for complex FFT routine cfft2. WPP 28 June 1996 */
main()
{
   int n,n2exp,i,isd,isd0,nit,kk,nexec;
/*
  repetition count:
                 16,    32,   64, 128,  256,  512, 1024, 2048,
                  |      |     |    |     |     |     |     | */
   int NX[17]={10000,10000,10000,10000,10000,1000, 1000, 1000,
            100, 100,   10,   10,    1,     1,     1,     1,      1};
/*            |    |     |     |     |      |      |      |       |
           4096,8192,16384,32768,65536,131072,262144,524288,1048576 */

   float eps,z0,z1,sign,fnm1,error,ln2,ran3();
   float mflops,t1,t2,t3,t4;
   void cffti(), cfft2();

/* print headers */

   printf("  ------------------------------------ \n");
   printf("           variant of CFFT2   \n");
   printf("  ------------------------------------ \n");

   isd  = 331;
   isd0 = 0;
   eps  = 2.*FLT_REL;
   for(n2exp=4;n2exp<=20;n2exp++){
      n     = pow(2,n2exp);
      t3    = 100000.;
      t4    = 100000.;
      nexec = 1;
      for(nit=0;nit<10;nit++){
         if(nit==0){
            for(i=0;i<n;i++){
               z0      = ran3(isd);
               z1      = ran3(isd0);
               x[i][0] = z0;
               x[i][1] = z1;
               z[i][0] = z0;
               z[i][1] = z1;
            }
         }
         else{
            for(i=0;i<n;i++){
               z0      = 0.;
               z1      = 0.;
               x[i][0] = z0;
               x[i][1] = z1;
               z[i][0] = z0;
               z[i][1] = z1;
            }
         }
         if(nit==0){
            cffti(n,w);
         }

/* forward transform */

         sign = 1.0;
         t1   = 1.e-6*((float)clock());
         for(kk=0;kk<nexec;kk++){
             cfft2(n,x,w,sign);
         }
         t1   = 1.e-6*((float)clock()) - t1;
         if(nit != 0) t3 = (t3<t1)?t3:t1;

/* backward transform */ 

         sign = -1.0;
         t2   = 1.e-6*((float)clock());
         for(kk=0;kk<nexec;kk++){
             cfft2(n,x,w,sign);
         }
         t2   = 1.e-6*((float)clock()) - t2;
         if(nit != 0) t4 = (t4<t2)?t4:t2;

/* first pass through, check errors */ 

         if(nit == 0){
            fnm1  = 1./((float) n);
            for(i=0;i<n;i++){
                z[i][0] = fnm1*x[i][0] - z[i][0];
                z[i][1] = fnm1*x[i][1] - z[i][1];
            }
            error = 0.0;
            for(i=0;i<n;i++){
                error = error + z[i][0]*z[i][0]+ z[i][1]*z[i][1];
            }
            error = sqrt(fnm1*error);
            if(error>eps) printf(" error in F/B = %e\n",error);
         }

         nexec = NX[n2exp-4];
      }
      t1     = 0.5*(t3+t4)/((float) nexec);
      printf(" cfft2 time for %d point transform = %e \n",n,t1);
      ln2    = (float) n2exp;
      mflops = 5.0*((float) n)*ln2/((1.e+6)*t1);
      printf(" cfft2 mflops = %e \n",mflops);
   }
}
